unit ShellPaths;

{
///////////////////////////////////////////////////////////////////////
// TSpecialFolders component
// Author: Helmut Schottmueller
// Contact: hschottm@gmx.de
// Copyright: (C) 2000 H. Schottmueller
// Version: 1.0
//
// This component is freeware. You are free to use it in any of your
// applications.
///////////////////////////////////////////////////////////////////////
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  TSpecialFolders = class(TComponent)
  private
  	function getShellPath(nFolder : Integer) : String;
    function Get_BitBucket: String;
    procedure Set_BitBucket(const Value: String);
    function Get_Controls: String;
    procedure Set_Controls(const Value: String);
    function Get_Desktop: String;
    procedure Set_Desktop(const Value: String);
    function Get_DesktopDirectory: String;
    procedure Set_DesktopDirectory(const Value: String);
    function Get_Drives: String;
    procedure Set_Drives(const Value: String);
    function Get_Fonts: String;
    procedure Set_Fonts(const Value: String);
    function Get_NetHood: String;
    procedure Set_NetHood(const Value: String);
    function Get_Network: String;
    procedure Set_Network(const Value: String);
    function Get_Personal: String;
    procedure Set_Personal(const Value: String);
    function Get_Printers: String;
    procedure Set_Printers(const Value: String);
    function Get_Programs: String;
    procedure Set_Programs(const Value: String);
    function Get_Recent: String;
    procedure Set_Recent(const Value: String);
    function Get_SendTo: String;
    procedure Set_SendTo(const Value: String);
    function Get_StartMenu: String;
    procedure Set_StartMenu(const Value: String);
    function Get_StartUp: String;
    procedure Set_Startup(const Value: String);
    function Get_Templates: String;
    procedure Set_Templates(const Value: String);
    { Private-Deklarationen }
  protected
    { Protected-Deklarationen }
  public
    { Public-Deklarationen }
  published
    { Published-Deklarationen }
    property BitBucket : String read Get_BitBucket write Set_BitBucket;
    property Controls : String read Get_Controls write Set_Controls;
    property Desktop : String read Get_Desktop write Set_Desktop;
    property DesktopDirectory : String read Get_DesktopDirectory write Set_DesktopDirectory;
    property Drives : String read Get_Drives write Set_Drives;
    property Fonts : String read Get_Fonts write Set_Fonts;
    property NetHood : String read Get_NetHood write Set_NetHood;
    property Network : String read Get_Network write Set_Network;
    property Personal : String read Get_Personal write Set_Personal;
    property Printers : String read Get_Printers write Set_Printers;
    property Programs : String read Get_Programs write Set_Programs;
    property Recent : String read Get_Recent write Set_Recent;
    property SendTo : String read Get_SendTo write Set_SendTo;
    property StartMenu : String read Get_StartMenu write Set_StartMenu;
    property Startup : String read Get_StartUp write Set_Startup;
    property Templates : String read Get_Templates write Set_Templates;
  end;

procedure Register;

implementation

{$R ShellPaths.res}

uses ShlObj, ActiveX, COMObj;

procedure Register;
begin
  RegisterComponents('3rdParty', [TSpecialFolders]);
end;

{ TShellPaths }

function TSpecialFolders.getShellPath(nFolder: Integer): String;
var
  ppidl    : PItemIDList;
  szPath  : array[0..MAX_PATH] of Char;
//  aMalloc : IMalloc;
begin
  OleCheck(SHGetSpecialFolderLocation(0, nFolder, ppidl));
  SHGetPathFromIDList(ppidl, szPath);
//  Der auskommentierte Code entspricht CoTaskMemFree
//  OleCheck(SHGetMalloc(aMalloc));
//  aMalloc.Free(pIIL);
	CoTaskMemFree(ppidl);
  Result := szPath;
end;

function TSpecialFolders.Get_Controls: String;
begin
	Result := getShellPath(CSIDL_CONTROLS	);
end;

function TSpecialFolders.Get_DesktopDirectory: String;
begin
	Result := getShellPath(CSIDL_DESKTOPDIRECTORY);
end;

function TSpecialFolders.Get_Fonts: String;
begin
	Result := getShellPath(CSIDL_FONTS);
end;

function TSpecialFolders.Get_Drives: String;
begin
	Result := getShellPath(CSIDL_DRIVES);
end;

function TSpecialFolders.Get_BitBucket: String;
begin
	Result := getShellPath(CSIDL_BITBUCKET);
end;

function TSpecialFolders.Get_Desktop: String;
begin
	Result := getShellPath(CSIDL_DESKTOP);
end;

function TSpecialFolders.Get_NetHood: String;
begin
	Result := getShellPath(CSIDL_NETHOOD);
end;

function TSpecialFolders.Get_Network: String;
begin
	Result := getShellPath(CSIDL_NETWORK);
end;

function TSpecialFolders.Get_Personal: String;
begin
	Result := getShellPath(CSIDL_PERSONAL);
end;

function TSpecialFolders.Get_Printers: String;
begin
	Result := getShellPath(CSIDL_PRINTERS);
end;

function TSpecialFolders.Get_Programs: String;
begin
	Result := getShellPath(CSIDL_PROGRAMS);
end;

function TSpecialFolders.Get_Recent: String;
begin
	Result := getShellPath(CSIDL_RECENT);
end;

function TSpecialFolders.Get_SendTo: String;
begin
	Result := getShellPath(CSIDL_SENDTO);
end;

function TSpecialFolders.Get_StartMenu: String;
begin
	Result := getShellPath(CSIDL_STARTMENU);
end;

function TSpecialFolders.Get_StartUp: String;
begin
	Result := getShellPath(CSIDL_STARTUP);
end;

function TSpecialFolders.Get_Templates: String;
begin
	Result := getShellPath(CSIDL_TEMPLATES);
end;

procedure TSpecialFolders.Set_Controls(const Value: String);
begin
end;

procedure TSpecialFolders.Set_DesktopDirectory(const Value: String);
begin
end;

procedure TSpecialFolders.Set_Fonts(const Value: String);
begin
end;

procedure TSpecialFolders.Set_Drives(const Value: String);
begin
end;

procedure TSpecialFolders.Set_BitBucket(const Value: String);
begin
end;

procedure TSpecialFolders.Set_Desktop(const Value: String);
begin
end;

procedure TSpecialFolders.Set_NetHood(const Value: String);
begin
end;

procedure TSpecialFolders.Set_Network(const Value: String);
begin
end;

procedure TSpecialFolders.Set_Personal(const Value: String);
begin
end;

procedure TSpecialFolders.Set_Printers(const Value: String);
begin
end;

procedure TSpecialFolders.Set_Programs(const Value: String);
begin
end;

procedure TSpecialFolders.Set_Recent(const Value: String);
begin
end;

procedure TSpecialFolders.Set_SendTo(const Value: String);
begin
end;

procedure TSpecialFolders.Set_StartMenu(const Value: String);
begin
end;

procedure TSpecialFolders.Set_Templates(const Value: String);
begin
end;

procedure TSpecialFolders.Set_Startup(const Value: String);
begin
end;

end.
